package p

import "reflect"
import "q"

var Global int = 100

type TestFuncType func(
	i int32, j int32, k int32, l int32, m int32, n int32,
	e float32, f float32, g float32, h float32,
	c complex64) (
	int32, int32, int32, int32, int32, int32,
	float32, float32, float32, float32,
	complex64)

func Test1(in []reflect.Value) []reflect.Value {
	println("Test1")
	Global++
	q.Global++
	q.Printvals(in)
	return in
}

func test2_int(in []reflect.Value) []reflect.Value {
	println("test2_int")
	Global++
	q.Global++
	q.Printvals(in)
	return in
}

var Test2 TestFuncType

func InitTest2() {
	makeTest2 := func(fptr interface{}) {
		fn := reflect.ValueOf(fptr).Elem()
		v := reflect.MakeFunc(fn.Type(), test2_int)
		fn.Set(v)
	}
	makeTest2(&Test2)
}

var Test3 TestFuncType

func InitTest3() {
	makeTest3 := func(fptr interface{}) {
		fn := reflect.ValueOf(fptr).Elem()
		v := reflect.MakeFunc(fn.Type(), q.Test3)
		fn.Set(v)
	}
	makeTest3(&Test3)
}

func Test4(in []reflect.Value) []reflect.Value {
	var test4 TestFuncType
	makeTest4 := func(fptr interface{}) {
		fn := reflect.ValueOf(fptr).Elem()
		v := reflect.MakeFunc(fn.Type(), q.Test4)
		fn.Set(v)
	}
	makeTest4(&test4)
	test4(7.0, 8.0, 9.0, 10.0, 11.0, 1, 2, 3, 4, 5, 6)
	return in
}

func Test5(in []reflect.Value) []reflect.Value {
	q.InitTest5()
	q.Test5(7.0, 8.0, 9.0, 10.0, 11.0, 1, 2, 3, 4, 5, 6)
	return in
}
