package q

import "reflect"
import "fmt"

var Global int = 200

type TestFuncType func(
	c complex64,
	e float32, f float32, g float32, h float32,
	i int32, j int32, k int32, l int32, m int32, n int32) (
	complex64,
	float32, float32, float32, float32,
	int32, int32, int32, int32, int32, int32)

func Printvals(vals []reflect.Value) {
	for i, v := range vals {
		fmt.Println(" ", i, v)
	}
}

func Test3(in []reflect.Value) []reflect.Value {
	println("Test3")
	Global++
	Printvals(in)
	return in
}

func Test4(in []reflect.Value) []reflect.Value {
	println("Test4")
	Global++
	Printvals(in)
	return in
}

func test5_int(in []reflect.Value) []reflect.Value {
	println("test5_int")
	Global++
	Printvals(in)
	return in
}

var Test5 TestFuncType

func InitTest5() {
	makeTest5 := func(fptr interface{}) {
		fn := reflect.ValueOf(fptr).Elem()
		v := reflect.MakeFunc(fn.Type(), test5_int)
		fn.Set(v)
	}
	makeTest5(&Test5)
}
